/**************************************************************************
 * HeXHub C++ SDK 0.2 Files Copyright (C) 2007-2008 Mikhail Polenin       *
 * HeXHub is Copyright(C) Albu Cristian Laurentiu                         *
 * This SDK's Purpose is to wrap around the HeXHub API to help plugin     *
 * developers organize their function calls and have more ease in coding  *
 * HeXHub Plugins.                                                        *
 * Files that should be included in this distribution:                    *
 *    HeXHubSDK.h - Header                                                *
 *    HeXHubSDK.cpp - Source File                                         *
 *    SDKReadme.txt - Documentation                                       *
 *    license.txt - License Information                                   *
 **************************************************************************/

//EDIT THIS VALUE FOR THE HEXHUB VERSION YOU INTEND TO WRITE FOR!!!!
#define HEX_VERSION 307





#ifndef WINDOWS_H
#include "windows.h"
#define WINDOWS_H
#endif

#define NICKBUFF		41
#define IPBUFF			15

#define ID_SECURITY_BOT	0

	typedef struct _profileInfo{
		char	rights[8];	//rights
		long	minAccess;	//minimum access
		long	maxAccess;	//maximum access
		long	accessIncrease;	//increment
		long	availability;	//availability in hours (0 = permanent)
	} profileInfo;

	typedef struct _accountInfo{
		long	reserved1;	//reserved
		char	name[40];	//user name
		short	profileId;	//profile identifier
		short	profileReset;	//identifier of the profile it resets to
		long	userId;		//user identifier
		char	rights[8];	//rights
		long	access;		//access level
		long	maxAccess;	//maximum access for current profile
		long	accessTime;	//timer increment
		long	availability;	//account availability
		long	maxClones;	//maximum clones allowed (if the account is for an IP)
		char	language[2];	//language identifier
		short	mode;		//last chat filter used
		char	password[40];	//password
		char	ipInformation;	//1 = IP/IP range, 2 = ISP, 3 = MAC
		long	IP1;		//first IP in range
		long	IP2;		//last IP in range
		char	ipstr[40];	//string containing IP, ISP or MAC (as ipInformation specifies)
		long	reserved2;	//reserved
		char	creator[40];	//nickname of the admin who created this account
		char	reserved3[8];	//reserved, date+time
		char	modifier[40];	//nickname of the last admin who modified this account
		char	reserved4[8];	//reserved, date+time
		char	reserved5[50];	//reserved
		char	reason[220];	//reason or comment
		char	reserved6[62];	//reserved
	} accountInfo;

	typedef struct _ipInfo{
		DWORD	lastIp;		//IP number
		WORD	timer1;
		WORD	timer2;
		WORD	timer3;
		WORD	timer4;
		WORD	timer5;		//timers used to check for reconnect flood
		BYTE	fcount;		//number of reconnects
		BYTE	flags1;		//flags
					//bit 0 => reserved
					//bit 1 => reserved
					//bit 2 => used by DDoS filter
					//bit 3 => IP was checked for public proxy
					//bit 4 => IP is a public proxy
					//bit 5 => from this IP a user was disconnected because of incorrect settings for active mode
					//bit 6 => this IP belongs to a faker and a notification message was sent
					//bit 7 => reserved
		DWORD	lastconn;	//last connection time in seconds relative to hub startup
		DWORD	tc_save;	//reserved
		BYTE	langtmp;	//language index in language table
		BYTE	invpasvd;	//number of invalid passwords sent
		BYTE	timeskicked;	//number of kicks
		BYTE	modetmp;	//last chat filter's index (used by older versions)
		BYTE	country;	//country name index
		BYTE	flagextra;	//flags
					//bit 0 => country ID was detected
					//bit 1 => user was banned for forbidden files in share, share size must change
		BYTE	share_check;	//checksum for share size
		BYTE	macaddr[6];	//MAC address
		BYTE	reserved[3];	//reserved
	} ipInfo;

	typedef struct _syn_info{
		long	lastCount;	//number of seconds since firewall was started when packet was sent
		long	sourceIP;	//source IP
		long	destinationIP;	//destination IP
		long	lastPort;	//destination port
		short	isflood;	//flood indicator, 1 = flood is detected
		short	reserved;	//reserved
	} syn_info;

	typedef struct _syn_str{
		char	syn_idx;	//index of next syn_info structure that will be used
		char	isFlood;	//detected flood type, 2 = portscan, 3 = SYN flood, 4 = UDP flood, 5 = ICMP flood
		long	lastIP;		//last IP that was detected as flooding
		syn_info sInfo[20];	//information about last sent packets
	} syn_str;

	typedef struct _firewallSettingsInfo{
		short	pcapFlags;	//flags used by WinPCap procedures, bit 0 = WinPCap enabled, bit 1 = adapters were detected
		short	pcapAdapters;	//flags used by WinPCap procedures to enable / disable adapters (bit 0 = first adapter, bit 1 = second adapter, etc)
		long	pcapTimeout;	//timeout used by WinPCap procedures for capturing packets
		char	maxSyn;		//maximum number of TCP/SYN packets / second allowed from same IP
		char	maxUdp;		//maximum number of UDP packets / second allowed from same IP
		char	maxIcmp;	//maximum number of ICMP packets / second allowed from same IP
		char	firewallFlags;	//flags used by firewall
					//	bit 0 => firewall is registered
					//	bit 1 => firewall is loaded
					//	bit 2 => SYN flood check on hub's ports is enabled
					//	bit 3 => SYN flood check on ports not used by hub is enabled
					//	bit 4 => incoming ICMP traffic is blocked
					//	bit 5 => TCP/RST packets are not sent on connection resets
					//	bit 6 => if flood is detected, a _ban0_ is added for source IP
					//	bit 7 => if flood is detected, a notification message is sent in opchat
		int	hubPortSyn;	//maximum number of SYN packets allowed to be sent to a port opened by hub
		int	otherPortsSyn;	//maximum number of SYN packets allowed to be sent to all other ports that are not used by hub
	} firewallSettingsInfo;

	typedef struct _firewallStatisticsInfo{
		syn_str	synFlood;	//statistics for SYN packets
		syn_str	udpFlood;	//statistics for UDP packets
		syn_str	icmpFlood;	//statistics for ICMP packets
		long	ddosSyn;	//filtered SYN packets sent from IPs found in DDoS filter
		long	banSyn;		//filtered SYN packets sent from banned IPs
		long	fltPort;	//filtered SYN packets sent to all registered ports if flood was detected
		long	reserved;	//pointer to last syn_str structure that was written
	} firewallStatisticsInfo;


typedef struct _iprange {
	long startip;
	long endip;
} iprange;

#define HEXHUBAPI __stdcall

typedef FARPROC (HEXHUBAPI *lpfnGetFunction)(void *);
typedef void (HEXHUBAPI *lpfnCreateAccount)(const char *, const char *, const char *, const char *, long);
typedef bool (HEXHUBAPI *lpfnDeleteAccount)(long);
typedef bool (HEXHUBAPI *lpfnMoveAccount)(long, long, long);
typedef bool (HEXHUBAPI *lpfnSetProfile)(long, const char *, profileInfo *, const char *, const char *);
typedef bool (HEXHUBAPI *lpfnGetProfile)(long, char *, profileInfo *, char *, char *);
typedef long (HEXHUBAPI *lpfnGetNextProfile)(long);
typedef bool (HEXHUBAPI *lpfnSetAccount)(long, accountInfo *);
typedef bool (HEXHUBAPI *lpfnGetAccount)(long, accountInfo *);
typedef long (HEXHUBAPI *lpfnGetNextAccount)(long, long);
typedef long (HEXHUBAPI *lpfnGetVersion)(void);
typedef long (HEXHUBAPI *lpfnGetUserCount)(void);
typedef long (HEXHUBAPI *lpfnGetUserIds)(long *, long);
typedef long (HEXHUBAPI *lpfnGetMastersCount)(void);
typedef long (HEXHUBAPI *lpfnGetMastersIds)(long *, long);
typedef bool (HEXHUBAPI *lpfnGetIpCacheInfo)(long, ipInfo *);
typedef void (HEXHUBAPI *lpfnSetIpCacheInfo)(ipInfo *);
typedef long (HEXHUBAPI *lpfnRegisterCommand)(const char *, void *);
typedef bool (HEXHUBAPI *lpfnUnregisterCommand)(long);
typedef long (HEXHUBAPI *lpfnRegisterHelpString)(const char *, const char *, long);
typedef bool (HEXHUBAPI *lpfnUnregisterHelpString)(long);
typedef long (HEXHUBAPI *lpfnRegisterUserCommand)(const char *);
typedef bool (HEXHUBAPI *lpfnUnregisterUserCommand)(long);
typedef long (HEXHUBAPI *lpfnRegisterChatFilter)(const char *, FARPROC, const char *);
typedef bool (HEXHUBAPI *lpfnUnregisterChatFilter)(long);
typedef long (HEXHUBAPI *lpfnRegisterBot)(const char *, FARPROC);
typedef long (HEXHUBAPI *lpfnRegisterBotEx)(const char *, FARPROC, long, long, long);
typedef bool (HEXHUBAPI *lpfnUnregisterBot)(long);
typedef bool (HEXHUBAPI *lpfnCallHubCommand)(long, const char *);
typedef bool (HEXHUBAPI *lpfnProcessUserTraffic)(long, FARPROC, long, long);
typedef bool (HEXHUBAPI *lpfnDisableOutputToUser)(long, FARPROC, bool);
typedef void (HEXHUBAPI *lpfnAcceptUser)(SOCKET, long);
typedef bool (HEXHUBAPI *lpfnDisconnectUser)(long);
typedef long (HEXHUBAPI *lpfnGetTopic)(char *, long);
typedef void (HEXHUBAPI *lpfnSetTopic)(const char *);
typedef long (HEXHUBAPI *lpfnGetMOTD)(char *, long);
typedef void (HEXHUBAPI *lpfnSetMOTD)(const char *);
typedef long (HEXHUBAPI *lpfnGetHubUptime)(void);
typedef long (HEXHUBAPI *lpfnGetHublistEntry)(long, char *, long);
typedef bool (HEXHUBAPI *lpfnSetBan)(long, long, long, char *, char *, long);
typedef bool (HEXHUBAPI *lpfnSendTo)(long, const char *, int);
typedef void (HEXHUBAPI *lpfnSendToAll)(const char *, int);
typedef void (HEXHUBAPI *lpfnSendNotificationMessage)(const char *);
typedef void (HEXHUBAPI *lpfnHTTPSendTo)(long, const char *, int, char *);
typedef void (HEXHUBAPI *lpfnHTTPSendHeaders)(long, const char *, int, char *);
typedef void (HEXHUBAPI *lpfnHTTPRedirect)(long, const char *);
typedef bool (HEXHUBAPI *lpfnNickFromId)(long, char *);
typedef bool (HEXHUBAPI *lpfnClientNickFromId)(long, char *);
typedef long (HEXHUBAPI *lpfnIdFromNick)(const char *);
typedef long (HEXHUBAPI *lpfnGetInfo)(long, char *);
typedef long (HEXHUBAPI *lpfnGetFullInfo)(long, char *);
typedef bool (HEXHUBAPI *lpfnSetInfo)(long, const char *);
typedef long (HEXHUBAPI *lpfnGetDescription)(long, char *);
typedef bool (HEXHUBAPI *lpfnSetDescription)(long, const char *);
typedef long (HEXHUBAPI *lpfnGetTag)(long, char *);
typedef bool (HEXHUBAPI *lpfnSetTag)(long, const char *);
typedef long (HEXHUBAPI *lpfnGetConnection)(long, char *);
typedef bool (HEXHUBAPI *lpfnSetConnection)(long, const char *);
typedef long (HEXHUBAPI *lpfnGetMail)(long, char *);
typedef bool (HEXHUBAPI *lpfnSetMail)(long, const char *);
typedef long (HEXHUBAPI *lpfnGetShareString)(long, char *);
typedef bool (HEXHUBAPI *lpfnSetShareString)(long, const char *);
typedef long (HEXHUBAPI *lpfnGetIP)(long);
typedef long (HEXHUBAPI *lpfnGetIPString)(long, char *);
typedef long (HEXHUBAPI *lpfnGetISPName)(long, char *);
typedef long (HEXHUBAPI *lpfnGetOpStatus)(long);
typedef bool (HEXHUBAPI *lpfnSetOpStatus)(long, long);
typedef long (HEXHUBAPI *lpfnGetLanguage)(long, char *);
typedef bool (HEXHUBAPI *lpfnSetLanguage)(long, const char *);
typedef long (HEXHUBAPI *lpfnGetMode)(long, char *);
typedef bool (HEXHUBAPI *lpfnSetMode)(long, const char *);
typedef long (HEXHUBAPI *lpfnModeTransform)(const char *, const char *, char *);
typedef long (HEXHUBAPI *lpfnAllocUserData)(void);
typedef bool (HEXHUBAPI *lpfnFreeUserData)(long);
typedef long (HEXHUBAPI *lpfnGetUserData)(long, long);
typedef bool (HEXHUBAPI *lpfnSetUserData)(long, long, char);
typedef int (HEXHUBAPI *lpfnFirewallGetVersion)(void);
typedef int (HEXHUBAPI *lpfnFirewallGetAboutString)(char *, int);
typedef int (HEXHUBAPI *lpfnFirewallEnable)(void);
typedef int (HEXHUBAPI *lpfnFirewallDisable)(void);
typedef int (HEXHUBAPI *lpfnFirewallBanRange)(iprange *);
typedef int (HEXHUBAPI *lpfnFirewallUnbanRange)(iprange *);
typedef short (HEXHUBAPI *lpfnFirewallLookupRange)(iprange *);
typedef int (HEXHUBAPI *lpfnFirewallGetSettings)(firewallSettingsInfo *);
typedef int (HEXHUBAPI *lpfnFirewallChangeSettings)(firewallSettingsInfo *);
typedef int (HEXHUBAPI *lpfnFirewallRegisterHubPort)(long);
typedef int (HEXHUBAPI *lpfnFirewallUnregisterHubPort)(long);
typedef int (HEXHUBAPI *lpfnFirewallGetStats)(firewallStatisticsInfo *);
typedef int (HEXHUBAPI *lpfnFirewallGetPortStats)(int, long *);
typedef int (HEXHUBAPI *lpfnDDoSFilterIP)(long);
typedef int (HEXHUBAPI *lpfnDDoSDeleteFilter)(void);
typedef int (HEXHUBAPI *lpfnDDoSCountFilteredIPs)(void);
typedef int (HEXHUBAPI *lpfnDDoSGetFilter)(void *, int);
typedef bool (HEXHUBAPI *lpfnGetRights)(long, long long *);
typedef bool (HEXHUBAPI *lpfnSetRights)(long, long long *);
typedef long (HEXHUBAPI *lpfnGetAccessLevel)(long);
typedef bool (HEXHUBAPI *lpfnSetAccessLevel)(long, long);
typedef long (HEXHUBAPI *lpfnGetProfileId)(long);
typedef long (HEXHUBAPI *lpfnGetAccountId)(long);

class HexHub
{
public:
	static lpfnGetFunction			GetFunction;
	bool Initialize(lpfnGetFunction GetFunction);
	class Core
	{
	public:
		class Accounts
		{
		public:
			static lpfnCreateAccount			CreateAccount;
			static lpfnDeleteAccount			DeleteAccount;
			static lpfnMoveAccount				MoveAccount;
			static lpfnSetProfile				SetProfile;
			static lpfnGetProfile				GetProfile;
			static lpfnGetNextProfile			GetNextProfile;
			static lpfnSetAccount				SetAccount;
			static lpfnGetAccount				GetAccount;
			static lpfnGetNextAccount			GetNextAccount;
		};
		static lpfnGetVersion					GetVersion;
		static lpfnGetUserCount					GetUserCount;
		static lpfnGetUserIds					GetUserIds;
		static lpfnGetMastersCount				GetMastersCount;
		static lpfnGetMastersIds				GetMastersIds;
		static lpfnGetIpCacheInfo				GetIpCacheInfo;
		static lpfnSetIpCacheInfo				SetIpCacheInfo;
		static lpfnRegisterCommand				RegisterCommand;
		static lpfnUnregisterCommand			UnregisterCommand;
		static lpfnRegisterHelpString			RegisterHelpString;
		static lpfnUnregisterHelpString			UnregisterHelpString;
		static lpfnRegisterUserCommand			RegisterUserCommand;
		static lpfnUnregisterUserCommand		UnregisterUserCommand;
		static lpfnRegisterChatFilter			RegisterChatFilter;
		static lpfnUnregisterChatFilter			UnregisterChatFilter;
		static lpfnRegisterBot					RegisterBot;
#if (HEX_VERSION >= 317)
		static lpfnRegisterBotEx				RegisterBotEx;
#endif
		static lpfnUnregisterBot				UnregisterBot;
		static lpfnCallHubCommand				CallHubCommand;
		static lpfnProcessUserTraffic			ProcessUserTraffic;
		static lpfnDisableOutputToUser			DisableOutputToUser;
		static lpfnAcceptUser					AcceptUser;
		static lpfnDisconnectUser				DisconnectUser;
#if (HEX_VERSION >= 307)
		static lpfnGetTopic						GetTopic;
		static lpfnSetTopic						SetTopic;
		static lpfnGetMOTD						GetMOTD;
		static lpfnSetMOTD						SetMOTD;
#endif
#if (HEX_VERSION >= 311)
		static lpfnGetHubUptime					GetHubUptime;
#endif
#if (HEX_VERSION >= 315)
		static lpfnGetHublistEntry				GetHublistEntry;
#endif
#if (HEX_VERSION >= 320)
		static lpfnSetBan						SetBan;
#endif
	};
	class Data
	{
	public:
		static lpfnSendTo						SendTo;
		static lpfnSendToAll					SendToAll;
		static lpfnSendNotificationMessage		SendNotificationMessage;
	};
#if (HEX_VERSION >= 500)
	class HTTP
	{
	public:
		static lpfnHTTPSendTo		HTTPSendTo;
		static lpfnHTTPSendHeaders	HTTPSendHeaders;
		static lpfnHTTPRedirect		HTTPRedirect;
	};
#endif
	class Users
	{
	public:
		class Registration
		{
		public:
			static lpfnGetRights			GetRights;
			static lpfnSetRights			SetRights;
			static lpfnGetAccessLevel		GetAccessLevel;
			static lpfnSetAccessLevel		SetAccessLevel;
			static lpfnGetProfileId			GetProfileId;
			static lpfnGetAccountId			GetAccountId;
		};
		static lpfnNickFromId				NickFromId;
		static lpfnClientNickFromId			ClientNickFromId;
		static lpfnIdFromNick				IdFromNick;
		static lpfnGetInfo					GetInfo;
		static lpfnGetFullInfo				GetFullInfo;
		static lpfnSetInfo					SetInfo;
		static lpfnGetDescription			GetDescription;
		static lpfnSetDescription			SetDescription;
		static lpfnGetTag					GetTag;
		static lpfnSetTag					SetTag;
		static lpfnGetConnection			GetConnection;
		static lpfnSetConnection			SetConnection;
		static lpfnGetMail					GetMail;
		static lpfnSetMail					SetMail;
		static lpfnGetShareString			GetShareString;
		static lpfnSetShareString			SetShareString;
		static lpfnGetIP					GetIP;
		static lpfnGetIPString				GetIPString;
		static lpfnGetISPName				GetISPName;
		static lpfnGetOpStatus				GetOpStatus;
		static lpfnSetOpStatus				SetOpStatus;
		static lpfnGetLanguage				GetLanguage;
		static lpfnSetLanguage				SetLanguage;
		static lpfnGetMode					GetMode;
		static lpfnSetMode					SetMode;
		static lpfnModeTransform			ModeTransform;
		static lpfnAllocUserData			AllocUserData;
		static lpfnFreeUserData				FreeUserData;
		static lpfnGetUserData				GetUserData;
		static lpfnSetUserData				SetUserData;
	};
#if (HEX_VERSION >= 400)
	class Firewall
	{
	public:
		static lpfnFirewallGetVersion			FirewallGetVersion;
		static lpfnFirewallGetAboutString		FirewallGetAboutString;
		static lpfnFirewallEnable				FirewallEnable;
		static lpfnFirewallDisable				FirewallDisable;
		static lpfnFirewallBanRange				FirewallBanRange;
		static lpfnFirewallUnbanRange			FirewallUnbanRange;
		static lpfnFirewallLookupRange			FirewallLookupRange;
		static lpfnFirewallGetSettings			FirewallGetSettings;
		static lpfnFirewallChangeSettings		FirewallChangeSettings;
		static lpfnFirewallRegisterHubPort		FirewallRegisterHubPort;
		static lpfnFirewallUnregisterHubPort	FirewallUnregisterHubPort;
		static lpfnFirewallGetStats				FirewallGetStats;
		static lpfnFirewallGetPortStats			FirewallGetPortStats;
		static lpfnDDoSFilterIP					DDoSFilterIP;
		static lpfnDDoSDeleteFilter				DDoSDeleteFilter;
		static lpfnDDoSCountFilteredIPs			DDoSCountFilteredIPs;
		static lpfnDDoSGetFilter				DDoSGetFilter;
	};
#endif
};